//+------------------------------------------------------------------+
//|                                                   SuperTrend.mq4 |
//|                                                                  |
//|                                      http://www.tradinformed.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Mark Ursell"
#property link      "http://www.tradinformed.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 FireBrick
#property indicator_color3 Green
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1 2 //1
#property indicator_width2 4 //2
#property indicator_width3 4 //2
#property indicator_style1 STYLE_DOT

// Constant definitions
#define INDICATOR_NAME "SuperTrend"


//---- input parameters
//extern int    SuperTrendPeriod=20;      // SuperTrend ATR Period
//extern double SuperTrendMultiplier=2.0; // SuperTrend Multiplier

extern int    SuperTrendPeriod=10;      // SuperTrend ATR Period
extern double SuperTrendMultiplier=2.5; // SuperTrend Multiplier


//---- buffers
double STUp[];
double STDn[];
double STSuperTrend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


  int init() {
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, STSuperTrend);
   SetIndexLabel(0, "SuperTrend");
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, STDn);
   SetIndexLabel(1, "SuperTrend Down");
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, STUp);
   SetIndexLabel(2, "SuperTrend Up");
   IndicatorShortName(INDICATOR_NAME+"["+SuperTrendPeriod+";"+DoubleToStr(SuperTrendMultiplier,1)+"]");


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Last Counted Bar will Be Recounted                                         |
//+------------------------------------------------------------------+
int start()
  {
 int iNewBars, iCountedBars, i;
  double dAtr,dUpperLevel, dLowerLevel;  
  
  // Get unprocessed ticks
  iCountedBars=IndicatorCounted();
  if(iCountedBars < 0) return (-1); 
  if(iCountedBars>0) iCountedBars--;
  iNewBars=Bars-iCountedBars;
  for(i=iNewBars; i>=0; i--)
  
   
//---- Calculation
{
    dAtr = iATR(NULL, 0, SuperTrendPeriod, i);
    dUpperLevel=(High[i]+Low[i])/2+SuperTrendMultiplier*dAtr;
    dLowerLevel=(High[i]+Low[i])/2-SuperTrendMultiplier*dAtr;


//---- Set Indicator Levels
    if (Close[i]>STSuperTrend[i+1] && Close[i+1]<=STSuperTrend[i+1]) {
      STSuperTrend[i]=dLowerLevel;
    }
    else if (Close[i]<STSuperTrend[i+1] && Close[i+1]>=STSuperTrend[i+1]) {
      STSuperTrend[i]=dUpperLevel;
    }
    else if (STSuperTrend[i+1]<dLowerLevel)
        STSuperTrend[i]=dLowerLevel;
    else if (STSuperTrend[i+1]>dUpperLevel)
        STSuperTrend[i]=dUpperLevel;
    else
      STSuperTrend[i]=STSuperTrend[i+1];
//---- Draw SuperTrend lines
    STUp[i]=EMPTY_VALUE;
    STDn[i]=EMPTY_VALUE;

    if (Close[i]>STSuperTrend[i] || (Close[i]==STSuperTrend[i] && Close[i+1]>STSuperTrend[i+1])) 
      STUp[i]=STSuperTrend[i];
    else if (Close[i]<STSuperTrend[i] || (Close[i]==STSuperTrend[i] && Close[i+1]<STSuperTrend[i+1])) 
      STDn[i]=STSuperTrend[i];  
      
  }    
      
      //////
      i=0;
      int curup =( STUp[i  ]>0 && STUp[i  ] < 1234567890) ? 1 : 0;
      int preup =( STUp[i+1]>0 && STUp[i+1] < 1234567890) ? 1 : 0;
      int curdn =( STDn[i  ]>0 && STDn[i  ] < 1234567890) ? 1 : 0;
      int predn =( STDn[i+1]>0 && STDn[i+1] < 1234567890) ? 1 : 0;

      if( curup == 1 && preup == 0 && predn == 1 && curdn == 0)
      {
//         PlaySound("tick.wav");
//         Alert(Symbol()+" Trying UP...  Cur-Up: "+DoubleToString(curup)+" "+DoubleToString(STUp[i]) +" Prev-Up:"+DoubleToString(preup)+" "+DoubleToString(STUp[i+1])+
//                                       "Cur-Dn: "+DoubleToString(curdn)+" "+DoubleToString(STDn[i]) +" Prev-Dn:"+DoubleToString(predn)+" "+DoubleToString(STDn[i+1]) );
      }

     
      if( curdn == 1 && predn == 0 && preup == 1 && curup == 0)
      {
//         PlaySound("tick.wav");
//         Alert(Symbol()+" Trying DOWN.  Cur-Dn: "+DoubleToString(curdn)+" "+DoubleToString(STDn[i]) +" Prev-Dn:"+DoubleToString(predn)+" "+DoubleToString(STDn[i+1])+
//                                       "Cur-Up: "+DoubleToString(curup)+" "+DoubleToString(STUp[i]) +" Prev-Up:"+DoubleToString(preup)+" "+DoubleToString(STUp[i+1]) );
      }
      
//     Alert(Symbol()+" Cur STS..."+IntegerToString(i)+"  Cur-Up: "+"  "+IntegerToString(curup)+" "+DoubleToString(STUp[i]) +" Prev-Up:"+IntegerToString(preup)+" "+DoubleToString(STUp[i+1])+
//                                       "Cur-Dn: "+IntegerToString(curdn)+" "+DoubleToString(STDn[i]) +" Prev-Dn:"+IntegerToString(predn)+" "+DoubleToString(STDn[i+1]) );

    
      
      //////
    
  return(0);
}
//+------------------------------------------------------------------+